/*======================================
  Arduino Control Center v2.2 by Lanmisoft
  ========================================*/
const MIN_DEVICE_ID = 10000;
const ALL_DEVICES = 2;
const loop_time = 10000;
const trigger_time = 2000;
var selected_device_id, io_pin, io_type, i_o, in_index, selected_row, device_user;
var acc_timers = [];
var chart_is_drawing = false;


(function ($) {
	"use strict";
	var mainApp = {

		main_fun: function () {
			/*====================================
			METIS MENU 
			======================================*/
			$('#main-menu').metisMenu();

			/*====================================
              LOAD MENU BAR
           ======================================*/
			$(window).bind("load resize", function () {
				if ($(this).width() < 768) {
					$('div.sidebar-collapse').addClass('collapse')
				} else {
					$('div.sidebar-collapse').removeClass('collapse')
				}
			});
		},

		initialization: function () {
			mainApp.main_fun();

		}

	}
	// Initializing ///

	// $(document).ready(function() {
	$(window).load(function () {
		mainApp.main_fun();
	});

}(jQuery));

function refreshTables() {
	// setTimeout("$('#device-single-update').click()", 2000);
	if (document.getElementById("auto-update-a").checked && (selected_device_id == ALL_DEVICES)) {
		$('#device-all-update').click();
	}
	if (document.getElementById("auto-update-single").checked && selected_device_id != ALL_DEVICES && selected_device_id >= MIN_DEVICE_ID) {
		$('#device-single-update').click();
	}
	acc_timers.push(setTimeout(refreshTables, loop_time));

};

function clearTimers() {
	for (var i = 0; i < acc_timers.length; i++) {
		clearTimeout(acc_timers[i]);
	}
};

function updatePWM(elem) { //onmouseup, touchend mobile
	var pwmlabel = document.getElementById("lb" + elem.id);
	pwmlabel.innerText = elem.value;
	$("#loader_" + elem.id).show();
	$("#loader_" + elem.id).slideDown(300);
	$("#loader_" + elem.id).Loadingdotdotdot({
		"speed": 400,
		"maxDots": 3,
		"word": '<span class=sid; style="color:#428BCA; font-size:12px;">' + elem.value + " sent, waiting" + '</span>'
	});
	$.ajax({
		type: "get",
		timeout: 1000,
		cache: false,
		data: {
			tooglepwmid: selected_device_id,
			tooglepwmpin: elem.id,
			tooglepwmval: elem.value
		}
	}).done(function (s) {
		var obj = $.parseJSON(s);

		$.each(obj, function (key, val) {

			if (key == "expired") {
				$("#loader_" + elem.id).slideUp(300);
				$('#sid').show();
				$('#sid').ScrollTo();;
				$('#sid').removeClass().addClass('alert alert-warning alert-dismissable');
				$('#sid').html(val + "<a href='login.html' class=alert-info><strong> Click here</strong></a> for redirecting to login page, or you will be redirected automatically after 15 seconds...");
				setTimeout(function () {
					window.location.href = 'login.html';
				}, 15000);
				return false;
			}

			if (key == "error") {
				$("#loader_" + elem.id).slideUp(300);
				$('#sid').removeClass().addClass('alert alert-warning');
				$('#sid').show();
				$('#sid').html(val);
				$('#sid').delay(5000).slideUp(300);
				$('#sid').ScrollTo();;
				return false;
			}


			if (key == "success") { //<span class=sid style=color:green font-size:8px!important;>Sending PWM value over network: '+ Arduino.BoardIP+':'+inttostr(Arduino.BoardPort)+'</span>'+'"
				$("#loader_" + elem.id).slideDown(300);
				$("#loader_" + elem.id).Loadingdotdotdot({
					"speed": 400,
					"maxDots": 0,
					"word": '<span class=sid; style="color:green; font-size:12px;">' + val + "</span>"
				});

				function refreshData() {
					$("#loader_" + elem.id).slideUp(300);
					$('#device-single-update').click();
					clearTimers();
					acc_timers.push(setTimeout(refreshTables, loop_time));
				};
				clearTimers();
				acc_timers.push(setTimeout(refreshData, trigger_time));

			};
			if (key == "rule") {
				$("#loader_" + elem.id).html('<span class=sid; style="font-size:12px;">' + val + "</span>");
				$("#loader_" + elem.id).show();
				$("#loader_" + elem.id).delay(3000).slideUp(300);

			};


		});
		var table_single = $('#device-single').DataTable();
		table_single.responsive.recalc();


	}).fail(function (jqXHR, textStatus, error) {
		// console.log("fail: " + jqXHR+"  "+textStatus+"  "+error);
		if (textStatus === "timeout")
			$('#load').html("<span class='sid' style=color:red;>Request timeout, failed to get data for device " + selected_device_id + "</span>");
		else
			$('#load').html("<span class='sid' style=color:red;>Failed to get data for device " + selected_device_id + "</span>");
		$('#load').delay(3000).slideUp(300);
	});


	// var table_single = $('#device-single').DataTable();
	//table_single.columns.adjust().draw('page'); 
}

function updatePWMChanges(elem) {
	var pwmlabel = document.getElementById("lb" + elem.id);
	pwmlabel.innerText = elem.value;
}

//end menu init
function toogleOutputs(clicked_id) {
	var digitalBtn = document.getElementById(clicked_id);
	if (digitalBtn == null) return;
	var check = digitalBtn.checked;

	$("#loader_" + clicked_id).slideDown(300);
	$("#loader_" + clicked_id).Loadingdotdotdot({
		"speed": 400,
		"maxDots": 3,
		"word": '<span class=sid; style="color:#428BCA; font-size:12px;">' + "Waiting response" + '</span>'
	});
	$.ajax({
		type: "get",
		timeout: 1000,
		cache: false,
		data: {
			toogledeviceid: selected_device_id,
			tooglepin: io_pin,
			toogleiotype: io_type,
			pinstatus:check
		} //pg is here device ID
	}).done(function (s) {
		var obj = $.parseJSON(s);

		$.each(obj, function (key, val) {

			if (key == "expired") {
				$("#loader_" + clicked_id).slideUp(300);
				$('#sid').show();
				$('#sid').ScrollTo();;
				$('#sid').removeClass().addClass('alert alert-warning alert-dismissable');
				$('#sid').html(val + "<a href='login.html' class=alert-info><strong> Click here</strong></a> for redirecting to login page, or you will be redirected automatically after 15 seconds...");
				setTimeout(function () {
					window.location.href = 'login.html';
				}, 15000);
				return false;
			}

			if (key == "error") {
				//  load_error = true;
				$("#loader_" + clicked_id).slideUp(300);
				$('#sid').removeClass().addClass('alert alert-warning');
				$('#sid').show();
				$('#sid').html(val);
				$('#sid').delay(5000).slideUp(300);
				$('#sid').ScrollTo();;
				return false;
			}


			if (key == "success") {
				$("#loader_" + clicked_id).slideDown(300);
				$("#loader_" + clicked_id).Loadingdotdotdot({
					"speed": 400,
					"maxDots": 0,
					"word": '<span class=sid; style="color:green; font-size:12px;">' + val + "</span>"
				});


				function refreshData() {
					$("#loader_" + clicked_id).slideUp(300);
					$('#device-single-update').click();
					clearTimers();
					acc_timers.push(setTimeout(refreshTables, loop_time));
				};
				clearTimers();
				acc_timers.push(setTimeout(refreshData, trigger_time));;

			};
			if (key == "rule") {
				$("#loader_" + clicked_id).html('<span class=sid; style="font-size:12px;">' + val + "</span>");
				$("#loader_" + clicked_id).show();
				$("#loader_" + clicked_id).delay(3000).slideUp(300);
				digitalBtn.checked = !digitalBtn.checked;
			};


		});
		var table_single = $('#device-single').DataTable();
		table_single.responsive.recalc();


	}).fail(function (jqXHR, textStatus, error) {
		// console.log("fail: " + jqXHR+"  "+textStatus+"  "+error);
		if (textStatus === "timeout")
			$('#load').html("<span class='sid' style=color:red;>Request timeout, failed to get data for device " + selected_device_id + "</span>");
		else
			$('#load').html("<span class='sid' style=color:red;>Failed to get data for device " + selected_device_id + "</span>");
		$('#load').delay(3000).slideUp(300);
	});

};


$(window).load(function () {

	var selected_single_row;
	var oldpage = 'page0';
	selected_device_id = ALL_DEVICES;

	//error handling
	window.onerror = function (message, filename, linenumber) {
		document.getElementById("auto-update-a").checked = false;
		document.getElementById("auto-update-single").checked = false;
		$('#sid').removeClass().addClass('alert alert-warning alert-dismissable');
		$('#sid').html("<span style=color:red; >Error: " + message + " File: " + filename + " Line: " + linenumber + "</span>");
		$('#sid').show();
		$('#sid').delay(10000).slideUp(500);
		$('#sid').removeClass().addClass('alert alert-warning alert-dismissable');
		$('#sid').html("<span style='font-size:0.8em;'; >Error: " + message + " File: " + filename + " Line: " + linenumber + "</span>");
		$('#load').delay(1000).slideUp(300);
		$('#sid').ScrollTo();
		return true;
	}


	//================ Initialization  and navigation====================================
	var table_log = $('#log-lines-table').DataTable({
		"bJQueryUI": false,
		"responsive": true,
		"processing": true,

		"columnDefs": [{
				"targets": [0]
						}

		],
		"aLengthMenu": [25, 50, 100],
		"iDisplayLength": 100,
		order: [0, 'asc']


	});	
	
	
	
	var table = $('#device-all').DataTable({
		"bJQueryUI": false,
		"responsive": true,
		"processing": true,

		"columnDefs": [{
				"targets": [0],
				"orderData": [0, 2]
			}, {
				"targets": [1],
				"className": "dt-center",
			},

			{
				"targets": [2],
				"visible": true,
				"searchable": true,
				"orderData": [2, 3]
			}, {
				"targets": [6], //ioid
				"visible": false,
				"searchable": true
			}, {
				"targets": [7],
				"visible": false,
				"searchable": false
			},

			{
				"targets": [3],
				"orderData": [3, 7]
			}

		],
		"aLengthMenu": [25, 50, 100],
		"iDisplayLength": 100,
		order: [3, 'asc']


	});


	$('#device-all').on('click', 'td', function () {
		var Col1 = $('td', this).eq(0).text();
		var rowindex = $(this).parent().index() + 1;
		var colindex = $(this).index() + 1;
		var cval = $(this).text();

	});

	$('#device-all tbody').on('click', 'tr', function () {

		if ($(this).hasClass('selected')) {
			$(this).removeClass('selected');
		} else {
			table.$('tr.selected').removeClass('selected');
			$(this).addClass('selected');

		}
		//var	selected_all_row =table.row( this ).index();
		//	alert(selected_all_row);

	});

	var table_single = $('#device-single').DataTable({
		"bJQueryUI": false,
		"responsive": true,
		"bStateSave": true, //ne radi-videti sa podacima
		"columnDefs": [

			{
				"targets": [0],
				"orderData": [9] //order pin num
			}, {
				"targets": [1],
				"className": "dt-center"
			},


			{
				"targets": [3],
				"orderData": [9] //order pin num
			},

			{
				"targets": [6],
				"visible": false //edit

			},
			{
				"targets": [7],
				"visible": false, //id
				"searchable": false
			}, {
				"targets": [8],
				"visible": false, //statistic
				"searchable": true
			}, {
				"targets": [9], //pin#
				"visible": false,
				"searchable": false
			}, {
				"targets": [10], //iotype
				"visible": false,
				"searchable": false
			}, {
				"targets": [11], //io
				"visible": false,
				"searchable": false
			}, {
				"targets": [12], //index
				"visible": false,
				"searchable": false
			},
			{
				"targets": [13], //username
				"visible": true,
				"searchable": false
			}
		],
		"paging": false,
		order: [9, 'asc']

	});


	$('#device-single tbody').on('click', 'tr', function () {

		if ($(this).hasClass('selected')) {
			$(this).removeClass('selected');
		} else {
			table_single.$('tr.selected').removeClass('selected');
			$(this).addClass('selected');

		}
		selected_row = table_single.row(this).index();

		selected_single_row = table_single.row(this).index();
		ioname = table_single.cell(this, 0).data();
		io_pin = table_single.cell(this, 9).data();
		io_type = table_single.cell(this, 10).data();
		i_o = table_single.cell(this, 11).data();
		in_index = table_single.cell(this, 12).data();
		device_user = table_single.cell(this, 13).data();

		document.getElementById("devices-chart").disabled = table_single.cell(this, 8).data() == "NO";
		// console.log(selected_device_id+" "+io_pin+" "+io_type+" "+i_o+" "+in_index);
		if (document.getElementById("devices-chart").disabled)
			document.getElementById("selected-device-graph").innerHTML = "<strong>" + ioname + "</strong>" + " doesn't have enabled saving data to database...";
		else
			document.getElementById("selected-device-graph").innerHTML = "IO/graph";

	});

	$('#device-all tbody').on('click', 'tr', function () {
		//   selected_device_graph = table.cell(this, 0).data();
	});

	$('.showhide').click(function () {
		jQuery('.hide-div').hide();
		var pg = $(this).attr('target');
		document.getElementById("devices-chart").disabled = true;
		if (pg >= MIN_DEVICE_ID) //change id			
			$('#' + oldpage).attr('id', 'page' + pg);

		jQuery('#page' + pg).show();
		selected_device_id = pg;
		//alert(selected_device_id);
		$('ul.nav').find('.active-menu').removeClass('active-menu');
		$(this).addClass('active-menu');
		document.getElementById("header-title").innerHTML = $(this).text();
		$('#header-title').ScrollTo();
		table_single.clear().draw();
		if (pg >= MIN_DEVICE_ID) {
			oldpage = 'page' + pg; //set oldid for page
		if (document.getElementById("show-update-a").checked == true){	
			$('#load').slideDown(300);
			$('#load').Loadingdotdotdot({
				"speed": 400,
				"maxDots": 4,
				"word": "Loading data for device " + pg
			});
		}
			
			table_single.columns.adjust().draw();


			$.ajax({
				type: "get",
				timeout: 30000,
				cache: false,
				data: {
					loaddeviceid: pg
				} //pg is here device ID
			}).done(function (s) {
				var obj = $.parseJSON(s);

				$.each(obj, function (key, val) {

					if (key == "expired") {
						$('#load').slideUp(300);
						$('#sid').show();
						$('#sid').ScrollTo();;
						$('#sid').removeClass().addClass('alert alert-warning alert-dismissable');
						$('#sid').html(val + "<a href='login.html' class=alert-info><strong> Click here</strong></a> for redirecting to login page, or you will be redirected automatically after 15 seconds...");
						setTimeout(function () {
							window.location.href = 'login.html';
						}, 15000);
						return false;
					}

					if (key == "error") {
						//  load_error = true;
						$('#sid').removeClass().addClass('alert alert-warning');
						$('#sid').show();
						$('#sid').html(val);
						$('#sid').delay(5000).slideUp(300);
						$('#sid').ScrollTo();;
						return false;
					}


					if (key == "data")
						for (var len = 0; len < val.length; len++) {
							table_single.row.add(val[len]).draw();

						};
				});

				table_single.responsive.recalc();
				// $('#load').delay(1000).slideUp(300);

			}).fail(function (jqXHR, textStatus, error) {
			
		
				// console.log("fail: " + jqXHR+"  "+textStatus+"  "+error);
				if (textStatus === "timeout")
					$('#load').html("<span class='sid' style=color:red;>Request timeout, failed to get data for device " + pg + "</span>");
				else
					$('#load').html("<span class='sid' style=color:red;>Failed to get data for device " + pg + "</span>");
				$('#load').delay(3000).slideUp(300);
			});

		}


		$(function () { //clear chart

			var datasets = {

				"empty": {
					label: "empty",
					color: "#008184",
					data: [
						[0, 0]
					]
				},

			};
			ChoiceContainer_io_All = $(".chart-container p");
			ChoiceContainer_io_All.empty();
			ChoiceContainer_io_All.append("<label> Select '" + pg + "'device I/O and Update Chart..</label>");

			function PlotInitChart() {

				var data = [];
				var key = "empty"
				data.push(datasets[key]);
				if (data.length > 0) {
					$.plot("#placeholder", data, {
						yaxis: {
							min: 0
						},
						xaxis: {
							tickDecimals: 0
						},
						legend: {

							noColumns: 2,
							position: "nw", //"ne" or "nw" or "se" or "sw"
						}
					});
				}
			}
			if (pg >= MIN_DEVICE_ID) {
				$('#device-single-update').click();
				PlotInitChart();

			} else
			if (pg == ALL_DEVICES) {
				$('#device-all-update').click();

			}
		});


	});


	$(function () {
		$("#from").datepicker({
			defaultDate: "+1w",
			changeMonth: true,
			numberOfMonths: 1,
			dateFormat: 'dd.mm.yy',
			onClose: function (selectedDate) {
				$("#to").datepicker("option", "minDate", selectedDate);
			}
		});
		$("#to").datepicker({
			defaultDate: "+1w",
			dateFormat: 'dd.mm.yy',
			changeMonth: true,
			numberOfMonths: 1,
			onClose: function (selectedDate) {
				$("#from").datepicker("option", "maxDate", selectedDate);
			}
		});
		$('#to').datepicker('setDate', '+0');
		$('#from').datepicker('setDate', '+0');


	});

	//===================End initialization and navigation=====================================	
	function showTooltip(x, y, contents) {
		$("<div id='tooltip'>" + contents + "</div>").css({
			position: "absolute",
			display: "none",
			top: y + 5,
			left: x + 5,
			border: "1px solid #fdd",
			padding: "2px",
			"background-color": "#fee",
			opacity: 0.80
		}).appendTo("body").fadeIn(200);
	}

	var previousPoint = null;
	$("#placeholder").bind("plothover", function (event, pos, item) {

		if (item) {
			if (previousPoint != item.dataIndex) {

				previousPoint = item.dataIndex;

				$("#tooltip").remove();
				var x = $.datepicker.formatDate('dd.mm', new Date(item.datapoint[0]));
				var time = new Date(item.datapoint[0]);
				var timestr = time.toLocaleTimeString("en-US", {
					hour12: false,
					timeZone: "UTC"
				});
				// var timestr = time.toLocaleTimeString("en-US", {
				//  hour12: false
				// });
				y = item.datapoint[1].toFixed(2);

				showTooltip(item.pageX, item.pageY,
					item.series.label + ", " + x + "-" + timestr + ", Value=" + y);
			}
		} else {
			$("#tooltip").remove();
			previousPoint = null;
		}

	});

	$("#devices-chart").click(function () {
		if (chart_is_drawing == true) {
			$('#load').show();
			$('#load').removeClass().addClass('alert-info');
			$('#load').Loadingdotdotdot({
				"speed": 400,
				"maxDots": 3,
				"word": "Request for drawing chart is already sent. Please wait..."
			});
			$('#load').ScrollTo();
			$('#load').delay(3000).slideUp(300);
			return;
		}

		chart_is_drawing = true;
		var filterbtn = this.id;
		this.disabled = true;
		//alert(selected_device_id);

		if ($("#from").val() == '' || $("#to").val() == '') {
			var dlg = $("#filterror").dialog({
				modal: true,
				autoOpen: false,
				draggable: false,
				resizable: false,
				width: 200,
				height: 80,

			});
			dlg.dialog("open");
		} else {
			var ChoiceContainer_io_All = $(".chart-container p");

			ChoiceContainer_io_All.empty();
			ChoiceContainer_io_All.css("color", "black");
			ChoiceContainer_io_All.css("font-weight", "bold");
			ChoiceContainer_io_All.Loadingdotdotdot({
				"speed": 400,
				"maxDots": 4,
				"word": "Drawing chart.."
			});

			var d = new Date()
			var n = d.getTimezoneOffset() * 60 * 1000;
			//	var unixfrom = Math.round(($("#from").datepicker("getDate")-n) / 1000);
			//var unixto =Math.round(($("#to").datepicker("getDate")-n) / 1000);
			var unixfrom = Math.round(($("#from").datepicker("getDate")) / 1000);
			var unixto = Math.round(($("#to").datepicker("getDate")) / 1000);
			$.ajax({
				type: "GET",
				datatype: "json",
				timeout: 120000,
				cache: false,
				data: {
					from: unixfrom,
					to: unixto,
					deviceid: selected_device_id,
					pin: io_pin,
					type: io_type,
					io: i_o,
					inindex: in_index,
					io_all: false,
					deviceUser: device_user
				},

				success: function (response) {
					var datasets = $.parseJSON(response);
					var i = 0;
					$.each(datasets, function (key, val) {
						val.color = "#008184"; //i;
						// ++i;

						if (key == "error") {
							$('#sid').show();
							$('#sid').removeClass().addClass('alert alert-warning');
							$('#sid').html(val);
							$('#sid').delay(5000).slideUp(300);
							$('#sid').ScrollTo();;
							return false;
						}

					});

					$("#devices-chart").removeAttr("disabled");
					$('#selected-device-graph').html("Device graph: <strong> " + selected_device_id + "</strong>");
					ChoiceContainer_io_All.css("font-weight", "100");
					ChoiceContainer_io_All.empty();
					$.each(datasets, function (key, val) {
						ChoiceContainer_io_All.append("<input type='checkbox' name='" + key + "' checked='checked' id='id" + key + "'></input>" + "<label for='id" + key + "'>" + val.label + "</label>");
					});

					ChoiceContainer_io_All.find("input").click(DrawChart_devices_All);
					ChoiceContainer_io_All.find("input").hide(); //no checkbox

					function DrawChart_devices_All() {

						var data = [];

						ChoiceContainer_io_All.find("input:checked").each(function () {
							var key = $(this).attr("name");
							if (key && datasets[key]) {
								data.push(datasets[key]);
							}
						});

						if (data.length > 0) {
							$.plot("#placeholder", data, {
								yaxis: {
									//tickDecimals: 0,
									autoScale: 'exact'
								},
								xaxis: {
								    mode: "time",
									minTickSize: [1, "hour"],


								},
								grid: {
									hoverable: true,
									clickable: true
								},
								lines: {
									steps: true
								}
							});
						}
						//var yaxisLabel = $("<div class='axisLabel yaxisLabel'></div>")
						//.text("Temperature").appendTo("#placeholder");
						//yaxisLabel.css("margin-top", yaxisLabel.width() / 2 - 20);

					}
					DrawChart_devices_All();
					chart_is_drawing = false;
					$('#load').delay(100).slideUp(300);
				},
				failure: function (msg) {
					chart_is_drawing = false;
					$('#load').delay(100).slideUp(300);
					ChoiceContainer_io_All.empty();
					ChoiceContainer_io_All.html("<p><strong>Failure! Cannot create new chart :( </strong></p>");

				},
				error: function (x, t, m) {
					if (t === "timeout") {
						chart_is_drawing = false;
						$('#load').delay(100).slideUp(300);
						ChoiceContainer_io_All.empty();
						ChoiceContainer_io_All.css("color", "#6190ca");
						ChoiceContainer_io_All.html("<p><strong>Request timeout, server not responding...</strong></p>");
						$("#devices_chart").removeAttr("disabled");
					} else {
						chart_is_drawing = false;
						$('#load').delay(100).slideUp(300);
						ChoiceContainer_io_All.empty();
						ChoiceContainer_io_All.css("color", "red");
						ChoiceContainer_io_All.html("<p><strong>Error! Server is not available or reponse is invalid!</strong></p>");
						$("#devices-chart").removeAttr("disabled");

					}
				}


			});

		}

	});
	//====================================

	$('#device-single-update, #device-all-update').click(function () { //<====================================================== Update tables=====================================
		if (chart_is_drawing == true) {
			$('#load').show();
			$('#load').removeClass().addClass('alert-info');
			$('#load').Loadingdotdotdot({
				"speed": 400,
				"maxDots": 3,
				"word": "Waiting for drawing chart"
			});
			return;
		}

		var btnID = this.id;
		if (document.getElementById("show-update-a").checked == true){
		$('#load').show();
		$('#load').removeClass().addClass('alert-info');
	    $('#load').Loadingdotdotdot({
			"speed": 400,
			"maxDots": 4,
			"word": "Loading devices data "
		});
		}
		$.ajax({
				type: "get",
				cache: false,
				timeout: 30000,
				data: {
					btnid: btnID, ///#device-single-update, #device-all-update
					device_id: selected_device_id,
				},
			}).done(function (response) {
				var obj = $.parseJSON(response);
				var single_rows = table_single.rows().indexes().length;
				var all_rows = table.rows().indexes().length;
				var ischanged = false;
				var changedcount = 0;
				var single_arr = [];
				var all_arr = [];
				var alarmHtml = '<img src="assets/img/alarm16.png" align="left" style="margin:2px 5px 0 -5px;">';
				for (var i = 0; i < single_rows; i++) {
					single_arr.push(i);
				}
				for (var i = 0; i < all_rows; i++) {
					all_arr.push(i);
				}

				$.each(obj, function (key, val) {


					if (key == "expired") {
						$('#load').slideUp(300);
						$('#sid').show();
						$('#sid').ScrollTo();;
						$('#sid').removeClass().addClass('alert alert-warning alert-dismissable');
						$('#sid').html(val + "<a href='login.html' class=alert-info><strong> Click here</strong></a> for redirecting to login page, or you will be redirected automatically after 15 seconds...");
						setTimeout(function () {
							window.location.href = 'login.html';
						}, 15000);
						return false;
					}

					if (key == "error") {
						//  load_error = true;
						$('#sid').removeClass().addClass('alert alert-warning');
						$('#sid').show();
						$('#sid').html(val);
						$('#sid').delay(5000).slideUp(300);
						$('#sid').ScrollTo();;
						return false;
					}

					if (key == "data" && selected_device_id != ALL_DEVICES && selected_device_id >= MIN_DEVICE_ID) {

						for (var len = single_arr.length - 1; len >= 0; len--) {
							var row = single_arr[len];
							var cell = table_single.cell(row);
							var IO_id = table_single.cell(row, 7).data();
							var Value = table_single.cell(row, 1).data();
							var IOName = table_single.cell(row, 0).data();

							$(table_single.cell(row, 1).node()).addClass('cell-value');

							for (i in obj.data) {
								IO_id_json = obj.data[i][0]; //id in json
								if (IO_id_json == IO_id) {
									var Value_json = obj.data[i][1];
									var last_data = obj.data[i][2];
									var pin = obj.data[i][4];
									var io = obj.data[i][5];
									var type = obj.data[i][6];
									var alarm = obj.data[i][7];


									if (alarm == true)
										$(table_single.cell(row, 0).node()).html(alarmHtml + IOName).addClass('error-cell');
									else
										$(table_single.cell(row, 0).node()).html(IOName).removeClass('error-cell');

									if (io == 1 & type > 0) { //=================================inputs============================================
										if (Value_json != Value) {
											if (Value_json == 'ERROR')
												$(table_single.cell(row, 1).data(Value_json).node()).addClass('error-cell');
											else
												$(table_single.cell(row, 1).data(Value_json).node()).removeClass('error-cell').addClass('changed-cell');
											$(table_single.cell(row, 5).data(last_data).node()).addClass('changed-cell');

											ischanged = true;
											changedcount++
										} else {
											if (Value_json == 'ERROR')
												$(table_single.cell(row, 1).data(Value_json).node()).removeClass('changed-cell').addClass('error-cell');
											else
												$(table_single.cell(row, 1).node()).removeClass('error-cell').removeClass('changed-cell');
											$(table_single.cell(row, 5).data(last_data).node()).removeClass('changed-cell');
										}

									};

									if (io == 1 && type == 0) { //===============================switch===========================================
										var digital = document.getElementById("dig_value" + pin);
										if (digital != null) {
											//  console.log(IO_id_json +"  "+digital);
											var boolcurrentstatus = digital.checked;
											//  console.log(IO_id_json +"  "+boolcurrentstatus);
											var pinstatus;
											if (boolcurrentstatus == true) pinstatus = 1;
											else pinstatus = 0;
											if (Value_json == 1) digital.checked = true;
											else
												digital.checked = false;
											if (Value_json != pinstatus) {
												ischanged = true;
												changedcount++
												$(table_single.cell(row, 5).data(last_data).node()).addClass('changed-cell');
											} else
												$(table_single.cell(row, 5).data(last_data).node()).removeClass('changed-cell');
										} else //==========view only ======
										{
											var digitalstatus;
											if (Value_json == 1) digitalstatus = 'HIGH';
											else
												digitalstatus = 'LOW';

											if (Value_json == 1)
												$(table_single.cell(row, 1).data(digitalstatus).node()).removeClass('digital-cell-low').addClass('digital-cell-high');
											else
												$(table_single.cell(row, 1).data(digitalstatus).node()).removeClass('digital-cell-high').addClass('digital-cell-low');
											if (digitalstatus != Value) {
												ischanged = true;
												changedcount++;
												$(table_single.cell(row, 5).data(last_data).node()).addClass('changed-cell');
											} else
												$(table_single.cell(row, 5).data(last_data).node()).removeClass('changed-cell');

										} //==========view only ======
									};

									if (io == 2 && (type < 4 || type == 25)) { //=================================digital=====================================
										var digital = document.getElementById("dig_value" + pin);
										if (digital != null) {
											var boolcurrentstatus = digital.checked;
											var pinstatus;
											if (boolcurrentstatus == true) pinstatus = 1;
											else pinstatus = 0;
											if (Value_json == 1) digital.checked = true;
											else
												digital.checked = false;
											// console.log(IO_id_json + "  " + Value_json);
											if (Value_json != pinstatus) {
												ischanged = true;
												changedcount++
												$(table_single.cell(row, 5).data(last_data).node()).addClass('changed-cell');

											} else
												$(table_single.cell(row, 5).data(last_data).node()).removeClass('changed-cell');
										} else //==========view only ======
										{
											var digitalstatus;
											if (Value_json == 1) digitalstatus = 'HIGH';
											else
												digitalstatus = 'LOW';

											if (Value_json == 1)
												$(table_single.cell(row, 1).data(digitalstatus).node()).removeClass('digital-cell-low').addClass('digital-cell-high');
											else
												$(table_single.cell(row, 1).data(digitalstatus).node()).removeClass('digital-cell-high').addClass('digital-cell-low');
											if (digitalstatus != Value) {
												ischanged = true;
												changedcount++;
												$(table_single.cell(row, 5).data(last_data).node()).addClass('changed-cell');
											} else
												$(table_single.cell(row, 5).data(last_data).node()).removeClass('changed-cell');

										} //==========view only ======
									};

									if (io == 2 && (type > 4 && type != 25)) { //===================================timer,counter===================================
										var tmcntStatus;
										if (Value_json == 1) tmcntStatus = 'HIGH';
										else
											tmcntStatus = 'LOW';
										if (Value_json == 0)
											$(table_single.cell(row, 1).data(tmcntStatus).node()).removeClass('digital-cell-high').addClass('digital-cell-low');
										if (Value_json == 1)
											$(table_single.cell(row, 1).data(tmcntStatus).node()).removeClass('digital-cell-low').addClass('digital-cell-high');
										if (tmcntStatus != Value) {
											$(table_single.cell(row, 5).data(last_data).node()).addClass('changed-cell');
											ischanged = true;
											changedcount++;
										} else
											$(table_single.cell(row, 5).data(last_data).node()).removeClass('changed-cell');


									};

									if (io == 2 && type == 4) { //=========================================pwm ==========================================
										var pwmlabel = document.getElementById("lbpwm_" + pin);
										if (pwmlabel != null) {
											Value = pwmlabel.innerText;
											pwmlabel.innerText = Value_json;
										}
										var pwm = document.getElementById("pwm_" + pin);
										if (pwm != null)
											pwm.value = Value_json;
										else ///view only
										{
											table_single.cell(row, 1).data(Value_json).node();

										}

										table_single.cell(row, 5).data(last_data).node();
										if (Value_json != Value) {
											ischanged = true;
											// changedcount++;
										}
									};

									table_single.cell(row, 5).data(last_data);
									single_arr.splice($.inArray(row, single_arr), 1);
									break;
								}
							}

							// load_error = false;
							// return true; 

						} //for 

					} //(key == "data") 


					if (key == "data" && selected_device_id == ALL_DEVICES) {

						for (var len = all_arr.length - 1; len >= 0; len--) {
							var row = all_arr[len];
							var cell = table.cell(row);
							var IO_id = table.cell(row, 6).data();
							var Value = table.cell(row, 1).data();
							var IOName = table.cell(row, 0).data();

							// pos = $.inArray(IO_id,obj.data[0]);

							for (i in obj.data) {
								IO_id_json = obj.data[i][0]; //id in json
								if (IO_id_json == IO_id) {
									var Value_json = obj.data[i][1];
									var last_data = obj.data[i][2];
									var io = obj.data[i][5];
									var type = obj.data[i][6];
									var alarm = obj.data[i][7];

									if (alarm == true)
										$(table.cell(row, 0).node()).html(alarmHtml + IOName).addClass('error-cell');
									else
										$(table.cell(row, 0).node()).html(IOName).removeClass('error-cell');

									if (io == 1 & type > 0) { //==========================================inputs, ALL =================================================
										if (Value_json != Value) {
											if (Value_json == 'ERROR')
												$(table.cell(row, 1).data(Value_json).node()).addClass('error-cell');
											else
												$(table.cell(row, 1).data(Value_json).node()).removeClass('error-cell').addClass('changed-cell');
											$(table.cell(row, 5).data(last_data).node()).addClass('changed-cell');

											ischanged = true;
											changedcount++
										} else {
											if (Value_json == 'ERROR')
												$(table.cell(row, 1).data(Value_json).node()).removeClass('changed-cell').addClass('error-cell');
											else
												$(table.cell(row, 1).node()).removeClass('error-cell').removeClass('changed-cell');
											$(table.cell(row, 5).data(last_data).node()).removeClass('changed-cell');
										}

									};

									if (io == 1 && type == 0) { //========================================switch ALL ================================================
										var digitalstatus;
										if (Value_json == 1) digitalstatus = 'HIGH';
										else
											digitalstatus = 'LOW';

										if (Value_json == 1)
											$(table.cell(row, 1).data(digitalstatus).node()).removeClass('digital-cell-low').addClass('digital-cell-high');
										else
											$(table.cell(row, 1).data(digitalstatus).node()).removeClass('digital-cell-high').addClass('digital-cell-low');
										if (digitalstatus != Value) {
											ischanged = true;
											changedcount++;
											$(table.cell(row, 5).data(last_data).node()).addClass('changed-cell');
										} else
											$(table.cell(row, 5).data(last_data).node()).removeClass('changed-cell');

									};

									if (io == 2 && (type < 4 || type == 25)) { //========================================digital ALL ================================================
										var digitalstatus;
										if (Value_json == 1) digitalstatus = 'HIGH';
										else
											digitalstatus = 'LOW';

										if (Value_json == 1)
											$(table.cell(row, 1).data(digitalstatus).node()).removeClass('digital-cell-low').addClass('digital-cell-high');
										else
											$(table.cell(row, 1).data(digitalstatus).node()).removeClass('digital-cell-high').addClass('digital-cell-low');
										if (digitalstatus != Value) {
											ischanged = true;
											changedcount++;
											$(table.cell(row, 5).data(last_data).node()).addClass('changed-cell');
										} else
											$(table.cell(row, 5).data(last_data).node()).removeClass('changed-cell');

									};

									if (io == 2 && (type > 4 && type != 25)) { //========================================timer,counter ALL ==========================================
										var tmcntStatus;
										if (Value_json == 1) tmcntStatus = 'HIGH';
										else
											tmcntStatus = 'LOW';
										if (Value_json == 0)
											$(table.cell(row, 1).data(tmcntStatus).node()).removeClass('digital-cell-high').addClass('digital-cell-low');
										if (Value_json == 1)
											$(table.cell(row, 1).data(tmcntStatus).node()).removeClass('digital-cell-low').addClass('digital-cell-high');
										if (tmcntStatus != Value) {
											ischanged = true;
											changedcount++;
											$(table.cell(row, 5).data(last_data).node()).addClass('changed-cell');
										} else
											$(table.cell(row, 5).data(last_data).node()).removeClass('changed-cell');

									};

									if (io == 2 && type == 4) { //===========================================pwm ALL ====================================================
										table.cell(row, 1).data(Value_json).node();

										if (Value_json != Value) {
											$(table.cell(row, 1).data(Value_json).node()).addClass('changed-cell');
											$(table.cell(row, 5).data(last_data).node()).addClass('changed-cell');
											ischanged = true;
											changedcount++;
										} else {
											$(table.cell(row, 1).node()).removeClass('changed-cell');
											$(table.cell(row, 5).data(last_data).node()).removeClass('changed-cell');
										}

									};


									all_arr.splice($.inArray(row, all_arr), 1);
									break;
								}
							}

							// load_error = false;
							// return true; 

						} //for 

					} //(key == "data") 	

				}); //each
                if (document.getElementById("show-update-a").checked == true){
				if (!ischanged && selected_device_id == ALL_DEVICES)
					$('#load').html("<span class='sid' style=color:#6633CC;>I/O data are NOT changed..</span>");
				else
				if (!ischanged && selected_device_id != ALL_DEVICES && selected_device_id >= MIN_DEVICE_ID)
					$('#load').html("<span class='sid' style=color:#6633CC;>I/O data for " + selected_device_id + " are NOT changed..</span>");
				else
					$('#load').html("Updated data for " + changedcount + " Inputs-Outputs");
				$('#load').delay(1000).slideUp(300);
			 }
				
			}) //end ajax "done" response
			.fail(function (jqXHR, textStatus, error) {
			  	$('#load').show();
				
				//console.log("fail: " + jqXHR+"  "+textStatus+"  "+error);
				if (textStatus === "timeout") {
					$('#load').removeClass().addClass('alert-warning');
					$('#load').ScrollTo();
					$('#load').html("<span class='sid' style=color:red;><strong>Request timeout, failed to get data!</strong></span>");
					$('#load').delay(3000).slideUp(300);

				} else {
					$('#load').removeClass().addClass('alert-warning');
					$('#load').ScrollTo();
					$('#load').html("<span class='sid' style=color:red;><strong>Failed to get data, server is not available!</strong></span>");
					$('#load').delay(3000).slideUp(300);

				};
			})

	})
	
	$('#logupdate').click(function () {
		$('#sid').removeClass().addClass('alert alert-info');
		$('#sid').show();
		$('#sid').html("Loading Server log...");
		$.ajax({
			datatype: "json",
			type: "GET",
			cache: false,
			timeout: 30000,
			data: {
				getlog: "getlogdata"
			},
			url: "index.html",
			success: function (response) {
				var obj = $.parseJSON(response);
				table_log.clear().draw();
				$('#sid').removeClass().addClass('alert alert-success');
				$('#sid').show();
				$('#sid').html("Server Log is updated!");
				$('#sid').delay(1500).slideUp(300);

				$.each(obj, function (key, val) {

					if (key == "error") {
						$('#sid').removeClass().addClass('alert alert-warning');
						$('#sid').show();
						$('#sid').html(val);
						$('#sid').delay(3000).slideUp(300);
						return false;
					}
					//if (key == "success") {
					//	$('#logtext').html(val);
				if (key == "success")
				for (var len = 0; len < val.length; len++) {
					var value = obj.success[len];
				table_log.row.add([value]).draw();
							};
							
			    	}); //each
			},

			failure: function (msg) {

				$('#sid').removeClass().addClass('alert alert-warning');
				$('#sid').show();
				$('#sid').html("<span class='sid' style=color:red;>" + msg + "</span>");
				$('#sid').delay(5000).slideUp(500);
				$('#sid').ScrollTo();;
			},
			error: function (x, t, m) {

				if (t === "timeout") {

					$('#sid').removeClass().addClass('alert alert-warning');
					$('#sid').show();
					$('#sid').html("<span class='sid'>Request timeout, server not responding!</span>")
					$('#sid').delay(5000).slideUp(500);
					$('#sid').ScrollTo();;
				} else {

					$('#sid').removeClass().addClass('alert alert-warning');
					$('#sid').show();
					$('#sid').html("<span class='sid' style=color:red;>Server is not available!</span>"); //
					$('#sid').delay(5000).slideUp(500);
					$('#sid').ScrollTo();

				}
			}

		});

	});
	
	$('#clearlog').click(function () {
	//$('#logtext').html('Click Update Log button in order to load data');
	table_log.clear().draw();
	});
	

	//=============================================END #devices-single-update, #device-all-update ===================================
	$('#passwordchange').bootstrapValidator({
		message: 'This value is not valid',
		icon: {
			valid: 'glyphicon glyphicon-ok',
			invalid: 'glyphicon glyphicon-remove',
			validating: 'glyphicon glyphicon-refresh'
		},

		fields: {


			password: {
				validators: {

					notEmpty: {
						message: 'The password is required and can\'t be empty'
					},
					stringLength: {
						min: 5,
						max: 15,
						message: 'The password must be more than 6 and less than 15 characters long'
					},
					regexp: {
						regexp: /^[A-z0-9!?@#_]{5,15}$/,
						message: 'Required at least 5 characters. Allowed characters (a-z,A-Z,0-9,!,?,@,#,_,)'
					},
				}
			},
			confirmPassword: {
				validators: {
					notEmpty: {
						message: 'The confirm password is required and can\'t be empty'
					},
					stringLength: {
						min: 5,
						max: 15,
						message: 'The password must be more than 5 and less than 15 characters long'
					},
					regexp: {
						regexp: /^[A-z0-9!?@#_]{5,15}$/,
						message: 'Required at least 5 characters. Allowed characters (a-z,A-Z,0-9,!,?,@,#,_,)'
					},
					identical: {
						field: 'password',
						message: 'The confirmed password does not match!'
					},

				}
			},

		}
	});


	$("#passwordchange").submit(function (e) {

		var pass = $(this).find("[name='password']").val();
		var confirmpass = $(this).find("[name='confirmPassword']").val();
		if (pass == "" || confirmpass == "" || pass != confirmpass) {
			return false
		};
		$('#sid').removeClass().addClass('alert alert-info');
		$('#sid').show();
		$('#sid').html("Executing query for password changing..");
		var form = $(this);
		$.ajax({
				url: form.attr('action'),
				type: form.attr('method'),
				data: form.serialize(),
			}).done(function (response) {
				var obj = $.parseJSON(response);

				$.each(obj, function (key, val) {

					if (key == "error") {
						$('#sid').removeClass().addClass('alert alert-warning');
						$('#sid').html(val);
						$('#sid').delay(5000).slideUp(300);
						$('#password-info').hide();
						$('#sid').ScrollTo();;
						return false;
					}

					if (key == "success") {

						$('#sid').removeClass().addClass('alert alert-success');
						$('#sid').html(val);
						$('#sid').delay(5000).slideUp(300);
						$('#sid').ScrollTo();
						$('#password-info').hide();
						$('#clear-passwords').click();
						return false;
					}


				}); //each

			})
			.fail(function (x, t, m) {

				if (t === "timeout") {
					$('#password-info').hide();
					$('#sid').html("<span class='sid' ><strong>Request timeout, server not responding!</strong></span>")
					$('#sid').delay(5000).slideUp(500);
					$('#sid').ScrollTo();;
				} else {
					$('#password-info').hide();
					$('#sid').html("<span class='sid' style=color:red;><strong>Server is not available!</strong></span>");
					$('#sid').delay(5000).slideUp(500);
					$('#sid').ScrollTo();;

				}
			})


		return false;
	});


	$('#clear-passwords').click(function () {
		var pass = $("[name='password']");
		var confirmpass = $("[name='confirmPassword']");
		pass.closest('.form-group').removeClass().addClass('form-group');
		confirmpass.closest('.form-group').removeClass().addClass('form-group');
		$('.help-block').hide();
	});

	
	//=============================================#


	function show() {
		chart_is_drawing = false;
		$('#device-all-update').click();
		$('#loading').hide();
		$('#wrapper').fadeIn();
		table.columns.adjust().draw();
	};
	setTimeout(show, 1000);

	refreshTables();


});