$(window).load(function() {
    var selected_user = "";
    var selectedacceslevel;
    var loggeduser = document.getElementById("logged").innerText;


    var table_users = $('#users-table').DataTable({
        "bJQueryUI": false,

        "aLengthMenu": [5, 10, 25, 50],
        "iDisplayLength": 5


    });

    $('#users-table tbody').on('click', 'tr', function() {

        if ($(this).hasClass('selected')) {
            $(this).removeClass('selected');
        } else {
            table_users.$('tr.selected').removeClass('selected');
            $(this).addClass('selected');

        }

        selected_user = table_users.cell(this, 0).data();
        selectedacceslevel = table_users.cell(this, 1).data();

    });


    function resetForm($form) {
        $form.find('input:text, input:password, input:file, select, textarea').val('');
        //  $form.find('input:radio, input:checkbox')
        //    .removeAttr('checked').removeAttr('selected');
    }

    $('#edit-user-data').bootstrapValidator({
        message: 'This value is not valid',
        fields: {
            editusername: {
                message: 'The username is not valid',
                validators: {
                    notEmpty: {
                        message: 'The username is required and can\'t be empty'
                    },
                    regexp: {
                        regexp: /^[A-z0-9]{5,15}$/,
                        message: 'Allowed characters (a-z,A-Z,0-9)'
                    },

                }
            },

            edituserpassword: {

                validators: {

                    notEmpty: {
                        message: 'The password is required and can\'t be empty'
                    },
                    stringLength: {
                        min: 5,
                        max: 15,
                        message: 'The password must be at least 5 and less than 15 characters long'
                    },
                    regexp: {
                        regexp: /^[a-zA-Z0-9!?@#_]+$/,
                        message: 'Required at least 5 characters. Allowed characters (a-z,A-Z,0-9,!,?,@,#,_,)'
                    },
                    different: {
                        field: 'editusername',
                        message: 'The username and password can\'t be the same as each other'
                    }
                }
            },
            edituserconfirmPassword: {
                validators: {
                    notEmpty: {
                        message: 'The confirm password is required and can\'t be empty'
                    },
                    stringLength: {
                        min: 5,
                        max: 15,
                        message: 'Required at least 5 characters. Allowed characters (a-z,A-Z,0-9,!,?,@,#,_,)'
                    },
                    regexp: {
                        regexp: /^[a-zA-Z0-9!?@#_]+$/,
                        message: 'Allowed characters (a-z,A-Z,0-9,!,?,@,#,_,)'
                    },

                    identical: {
                        field: 'edituserpassword',
                        message: 'The confirmed password does not match!'
                    },

                }
            },

        }
    });

    $('#new-user-data').bootstrapValidator({
        message: 'This value is not valid',
        fields: {
            newusername: {
                message: 'The username is not valid',
                validators: {
                    notEmpty: {
                        message: 'The username is required and can\'t be empty'
                    },
                    stringLength: {
                        min: 5,
                        max: 15,
                        message: 'The username must be more than 5 and less than 15 characters'
                    },
                    regexp: {
                        regexp: /^[A-z0-9]{5,15}$/,
                        message: 'Allowed characters (a-z,A-Z,0-9)'
                    },

                }
            },

            newuserpassword: {
                validators: {

                    notEmpty: {
                        message: 'The password is required and can\'t be empty'
                    },
                    stringLength: {
                        min: 5,
                        max: 15,
                        message: 'The password must be more than 5 and less than 15 characters long'
                    },
                    regexp: {
                        regexp: /^[A-z0-9!?@#_]{5,15}$/,
                        message: 'Required at least 5 characters. Allowed characters (a-z,A-Z,0-9,!,?,@,#,_,)'
                    },
                    different: {
                        field: 'newusername',
                        message: 'The username and password should not be the same as each other'
                    }
                }
            },
            newuserconfirmPassword: {
                validators: {
                    notEmpty: {
                        message: 'The confirm password is required and can\'t be empty'
                    },
                    stringLength: {
                        min: 5,
                        max: 15,
                        message: 'The password must be more than 5 and less than 15 characters long'
                    },
                    regexp: {
                        regexp: /^[A-z0-9!?@#_]{5,15}$/,
                        message: 'Required at least 5 characters. Allowed characters (a-z,A-Z,0-9,!,?,@,#,_,)'
                    },

                    identical: {
                        field: 'newuserpassword',
                        message: 'The confirmed password does not match!'
                    },

                }
            },

        }
    });


    $('#edit-user').click(function() { //pre otvaranja edit prozora
        var len = table_users.rows().indexes().length;
        var msg, error;
        if (len == 0) {
            msg = "Refresh users list first!";
            error = true;
        } else if (selected_user == "" || selected_user == undefined) {
            msg = "Select user first!!";
            error = true;
        };
        if (error) {
            $('#sid').removeClass().addClass('alert alert-warning');
            $('#sid').show();
            $('#sid').html(msg);
            $('#sid').delay(2000).slideUp(300);
            $('#sid').ScrollTo();
            return false;
        };

        resetForm($('#edituser-form'));
        var access = $('select[name="edit-access"]');
        if (selectedacceslevel == "Standard User") {
            //access.empty() 
            //access.append(new Option("Standard User"));
            access.val("Standard User")
        } else if (selectedacceslevel == "Administrator") {
            access.val("Administrator")
        } else if (selectedacceslevel == "Site-Admin") {
            access.val("Site-Admin")
        };
        var username = $("[name='editusername']");
        username.val(selected_user);
        var pass = $("[name='edituserpassword']");
        var confirmpass = $("[name='edituserconfirmPassword']");
        pass.closest('.form-group').removeClass().addClass('form-group');
        confirmpass.closest('.form-group').removeClass().addClass('form-group');
        username.closest('.form-group').removeClass().addClass('form-group');
        $('.help-block').hide();

    });

    $("#edituser-form").on("shown.bs.modal", function(e) {
        $("[name='edituserpassword']").focus();
    });

    $("#edit-user-data").submit(function(e) { //edit user form

        var pass = $(this).find("[name='edituserpassword']").val();
        var confirmpass = $(this).find("[name='edituserconfirmPassword']").val();
        if (pass == "" || confirmpass == "" || pass != confirmpass) {
            return false
        };

        $('#edit-info').removeClass().addClass('alert alert-info');
        $('#edit-info').show();
        $('#edit-info').html("Executing query..");
        var form = $(this);
        $.ajax({
            url: form.attr('action'),
            type: form.attr('method'),
            data: form.serialize(),
            success: function(response) {
                var obj = $.parseJSON(response);
                var len = table_users.rows().indexes().length;
                var editform = $('#edituser-form');
                $.each(obj, function(key, val) {

                    if (key == "error") {
                        $('#edit-info').hide();
                        $('#sid').removeClass().addClass('alert alert-warning');
                        $('#sid').show();
                        $('#sid').html(val);
                        $('#sid').delay(3000).slideUp(300);
                        $('#sid').ScrollTo();
                        editform.modal('hide');
                        return false;
                    }
                    if (key == "success") {
                        $('#edit-info').hide();
                        $('#sid').removeClass().addClass('alert alert-success');
                        $('#sid').show();
                        $('#sid').html(val);
                        $('#sid').delay(3000).slideUp(300);
                        $('#sid').ScrollTo();
                        for (var cellIdx = 0; cellIdx < len; cellIdx++) {
                            user = table_users.cell(cellIdx, 0).data();
                            var username = $("[name='editusername']").val();
                            if (user == username) {
                                accessvalue = $("#edit-access-id").val();
                                table_users.cell(cellIdx, 1).data(accessvalue);
                                editform.modal('hide');
                                return false;
                            };

                        } //for 
                        return false;
                    }




                }); //each


            },

            failure: function(msg) {
                $('#edit-info').hide();
                editform.modal('hide');
                $('#sid').removeClass().addClass('alert alert-warning');
                $('#sid').show();
                $('#sid').html("<span class='sid' style=color:red;>" + msg + "</span>");
                $('#sid').delay(5000).slideUp(500);
                $('#sid').ScrollTo();
            },
            error: function(x, t, m) {

                if (t === "timeout") {
                    $('#edit-info').hide();
                    editform.modal('hide');
                    $('#sid').removeClass().addClass('alert alert-warning');
                    $('#sid').show();
                    $('#sid').html("<span class='sid'>Request timeout, server not responding!</span>")
                    $('#sid').delay(5000).slideUp(500);
                } else {
                    $('#edit-info').hide();
                    editform.modal('hide');

                    $('#sid').removeClass().addClass('alert alert-warning');
                    $('#sid').show();
                    $('#sid').html("<span class='sid' style=color:red;>Server is not available!</span>"); //
                    $('#sid').delay(5000).slideUp(500);

                }
            }



        });

        return false;
    });




    $('#clear-edituser').click(function() {
        var access = $('select[name="edit-access"]');
        access.val(access.find('option').first().val());
        var pass = $("[name='edituserpassword']");
        var confirmpass = $("[name='edituserconfirmPassword']");
        var editusername = $("[name='editusername']");
        pass.val("");
        confirmpass.val("");
        pass.closest('.form-group').removeClass().addClass('form-group');
        confirmpass.closest('.form-group').removeClass().addClass('form-group');
        editusername.closest('.form-group').removeClass().addClass('form-group');
        $('.help-block').hide();
    })




    $('#delete-user').click(function() { //delete user

        var len = table_users.rows().indexes().length;
        var msg, error;
        if (len == 0) {
            msg = "Refresh users list first!";
            error = true;
        } else if (selected_user == "" || selected_user == undefined) {
            msg = "Select user first!!";
            error = true;
        };
        if (error) {
            $('#sid').removeClass().addClass('alert alert-warning');
            $('#sid').show();
            $('#sid').html(msg);
            $('#sid').delay(2000).slideUp(300);
            $('#sid').ScrollTo();
            return false;
        }

        bootbox.confirm("Are you sure you want delete user <strong>" + selected_user + "?</strong>", function(result) {
            if (result === true) {

                $('#sid').removeClass().addClass('alert alert-info');
                $('#sid').show();
                $('#sid').html("Executing delete query...");
                $.ajax({
                    datatype: "json",
                    type: "POST",
                    cache: false,
                    timeout: 30000,
                    data: {
                        deleteuser: selected_user
                    },
                    url: "index.html",
                    success: function(response) {
                        var obj = $.parseJSON(response);


                        $.each(obj, function(key, val) {

                            if (key == "error") {
                                $('#sid').removeClass().addClass('alert alert-warning');
                                $('#sid').show();
                                $('#sid').html(val);
                                $('#sid').ScrollTo();
                                $('#sid').delay(3000).slideUp(300);
                                return false;
                            }

                            if (key == "success") {
                                $('#sid').removeClass().addClass('alert alert-success');
                                $('#sid').show();
                                $('#sid').ScrollTo();
                                $('#sid').html(val).delay(3000).slideUp(300);

                                var rows = table_users.rows('.selected').remove().draw();

                                selected_user = "";
                                selectedacceslevel = "";
                            }
                        }); //each

                    },

                    failure: function(msg) {

                        $('#sid').removeClass().addClass('alert alert-warning');
                        $('#sid').show();
                        $('#sid').html("<span class='sid' style=color:red;>" + msg + "</span>");
                        $('#sid').delay(5000).slideUp(500);
                        $('#sid').ScrollTo();;
                    },
                    error: function(x, t, m) {

                        if (t === "timeout") {

                            $('#sid').removeClass().addClass('alert alert-warning');
                            $('#sid').show();
                            $('#sid').html("<span class='sid'>Request timeout, server not responding!</span>")
                            $('#sid').delay(5000).slideUp(500);
                            $('#sid').ScrollTo();;
                        } else {

                            $('#sid').removeClass().addClass('alert alert-warning');
                            $('#sid').show();
                            $('#sid').html("<span class='sid' style=color:red;>Server is not available!</span>"); //
                            $('#sid').delay(5000).slideUp(500);
                            $('#sid').ScrollTo();

                        }
                    }

                });
            } //delete result
        }); //delete prompt
    });



    $('#add-user,#clear-newuser').click(function() {
        resetForm($('#adduser-form'));
        var access = $('select[name="add-access"]');
        access.val(access.find('option').first().val());
        var pass = $("[name='newuserpassword']");
        var confirmpass = $("[name='newuserconfirmPassword']");
        var newusername = $("[name='newusername']");
        pass.val("");
        confirmpass.val("");
        pass.closest('.form-group').removeClass().addClass('form-group');
        confirmpass.closest('.form-group').removeClass().addClass('form-group');
        newusername.closest('.form-group').removeClass().addClass('form-group');
        $('.help-block').hide();

    })

    $("#adduser-form").on("shown.bs.modal", function(e) {
        $("[name='newusername']").focus();
        document.getElementById("user_prefix").innerText = loggeduser + "-";
    });

    $("#new-user-data").submit(function(e) { //new user form
        var pass = $(this).find("[name='newuserpassword']").val();
        var pass = $(this).find("[name='newuserpassword']").val();
        var confirmpass = $(this).find("[name='newuserconfirmPassword']").val();
        var username = $(this).find("[name='newusername']").val();
        if (pass == "" || confirmpass == "" || username == "" || pass != confirmpass) {
            return false
        };

        $('#newuser-info').removeClass().addClass('alert alert-info');
        $('#newuser-info').show();
        $('#newuser-info').html("Executing query..");

        var form = $(this);
        $.ajax({
            url: form.attr('action'),
            type: form.attr('method'),
            data: form.serialize() + "&logged=" + loggeduser,
            success: function(response) {
                var obj = $.parseJSON(response);
                var newform = $('#adduser-form');
                $.each(obj, function(key, val) {



                    if (key == "error") {
                        $('#newuser-info').hide();
                        $('#sid').removeClass().addClass('alert alert-warning');
                        $('#sid').show();
                        $('#sid').html(val);
                        $('#sid').delay(3000).slideUp(300);
                        $('#sid').ScrollTo();
                        newform.modal('hide');
                        return false;
                    }

                    if (key == "userexists") {

                        $('#newuser-info').removeClass().addClass('alert alert-warning');
                        $('#newuser-info').show().delay(3000).slideUp(300);;
                        $('#newuser-info').html(val);
                        $("[name='newusername']").val("").focus();

                        return false;
                    }

                    if (key == "success") {

                        $('#newuser-info').removeClass().addClass('alert alert-success');
                        $('#newuser-info').show().delay(3000).slideUp(300);;
                        $('#newuser-info').html(val);


                    }

                    if (key == "newuser") {

                        table_users.row.add([val[0], val[1]]).draw();
                        $('#clear-newuser').click(); //clear form	
                        $("[name='newusername']").focus();
                    }



                }); //each

            },

            failure: function(msg) {
                $('#newuser-info').hide();
                newform.modal('hide');

                $('#sid').removeClass().addClass('alert alert-warning');
                $('#sid').show();
                $('#sid').html("<span class='sid' style=color:red;>" + msg + "</span>");
                $('#sid').delay(5000).slideUp(500);
                $('#sid').ScrollTo();;
            },
            error: function(x, t, m) {

                if (t === "timeout") {
                    $('#newuser-info').hide();
                    newform.modal('hide');
                    $('#sid').removeClass().addClass('alert alert-warning');
                    $('#sid').show();
                    $('#sid').html("<span class='sid'>Request timeout, server not responding!</span>")
                    $('#sid').delay(5000).slideUp(500);
                    $('#sid').ScrollTo();;
                } else {
                    $('#newuser-info').hide();
                    newform.modal('hide');
                    $('#sid').removeClass().addClass('alert alert-warning');
                    $('#sid').show();
                    $('#sid').html("<span class='sid' style=color:red;>Server is not available!</span>"); //
                    $('#sid').delay(5000).slideUp(500);

                }
            }

        });

        return false;
    });




    $('#refresh-users').click(function() {
        $('#sid').removeClass().addClass('alert alert-info');
        $('#sid').show();
        $('#sid').html("Loading Users...");
        $.ajax({
            datatype: "json",
            type: "GET",
            cache: false,
            timeout: 30000,
            data: {
                checkusers: "check"
            },
            url: "index.html",
            success: function(response) {
                var obj = $.parseJSON(response);
                var accesslevelstr;
                selected_user = "";
                selectedacceslevel = "";
                table_users.clear().draw();
                $('#sid').removeClass().addClass('alert alert-success');
                $('#sid').show();
                $('#sid').html("Users list loaded!");
                $('#sid').delay(1500).slideUp(300);

                $.each(obj, function(key, val) {

                    if (key == "error") {
                        $('#sid').removeClass().addClass('alert alert-warning');
                        $('#sid').show();
                        $('#sid').html(val);
                        $('#sid').delay(3000).slideUp(300);
                        return false;
                    }
                    // var options = $("#users-list"); 
                    //options.empty() 
                    //  var i=0;
                    // while (val[i]){
                    //options.append(new Option(val[i])); 
                    //i++ 
                    // }

                    if (val[0] == 0) {
                        accesslevelstr = "Standard User"
                    } else
                    if (val[0] == 1) {
                        accesslevelstr = "Administrator"
                    } else
                    if (val[0] == 2) {
                        accesslevelstr = "Site-Admin"
                    } else {
                        accesslevelstr = "Unknown-error"
                    };

                    table_users.row.add([key, accesslevelstr]).draw();


                }); //each

            },

            failure: function(msg) {

                $('#sid').removeClass().addClass('alert alert-warning');
                $('#sid').show();
                $('#sid').html("<span class='sid' style=color:red;>" + msg + "</span>");
                $('#sid').delay(5000).slideUp(500);
                $('#sid').ScrollTo();;
            },
            error: function(x, t, m) {

                if (t === "timeout") {

                    $('#sid').removeClass().addClass('alert alert-warning');
                    $('#sid').show();
                    $('#sid').html("<span class='sid'>Request timeout, server not responding!</span>")
                    $('#sid').delay(5000).slideUp(500);
                    $('#sid').ScrollTo();;
                } else {

                    $('#sid').removeClass().addClass('alert alert-warning');
                    $('#sid').show();
                    $('#sid').html("<span class='sid' style=color:red;>Server is not available!</span>"); //
                    $('#sid').delay(5000).slideUp(500);
                    $('#sid').ScrollTo();

                }
            }

        });

    });



});